﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Data;
using System.Runtime.Serialization;

namespace IContract 
{
    [ServiceContract]
    [ServiceKnownType(typeof(User))]
    public interface IContract
    {
        [OperationContract]
        [WebInvoke(RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json)]
        double Add(double x, double y);

        [OperationContract]
        [WebGet(RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json)]
        string Hello(string mes);

        [OperationContract]
        [ServiceKnownType(typeof(User))]
        [WebGet(RequestFormat = WebMessageFormat.Json, ResponseFormat = WebMessageFormat.Json)]
        IList<User> getlist();

    }

    [Serializable]
    [DataContract]
    [ServiceKnownType(typeof(User))]
    public class User
    {
        [DataMember]
        public string Name{get;set;}
        [DataMember]
        public int Age { get; set; }
    }
}
